(function() {
	if (typeof WC === "undefined") {
		console.log("frame should supported by wechat-core!");
		return;
	}
	WC.account = {
		settings : {
			pageCls : "page",
			gobackCls : "back",
			content : "<div class=\"simplebox\"></div>",
			formline : "<div style=\"text-align: center\"></div>",
			session : {
				//wxid : WC.util.search("wxid")
			},
			first : "dealer_name",
			last : "dealer_success",
			bindAction : "isBindForApp",
			steps : {
				"dealer_name" : {
					buttons : [ {
						innerHtml : '<a href="javascript:void(0)" class="submit-button no-bottom demo-button button-minimal submit-button  no-bottom "></a>',
						text : "下一步",
						target : "dealer_select",
						action : 'dealerlist',
						required : [ "dealername", "brandcode" ],
					} ],
					url : "account_step1.html",
					loader : [ {
						id : 'brand_select',
						dataurl : 'getbrand'
					} ]
				},
				"dealer_select" : {
					buttons : [ {
						innerHtml : '<a href="javascript:void(0)" class="submit-button no-bottom demo-button button-minimal submit-button  no-bottom "></a>',
						text : "重新输入",
						target : "dealer_name"
					} ],
					url : "account_step2.html",
					prev : "dealer_name",
				},
				"dealer_sign" : {
					buttons : [ {
						innerHtml : '<a href="javascript:void(0)" class="submit-button no-bottom demo-button button-minimal submit-button  no-bottom "></a>',
						text : "注册",
						target : "dealer_success",
						action : 'appreg',
						required : [ "brandcode", "apppwd", "appaccount",
								"dealerid", "custname", "jobdesc", "linktel",
								"email" ]
					} ],
					url : "account_step3.html",
					prev : "dealer_name"
				},
				"dealer_success" : {
					url : "account_success.html"
				}
			},
			gen : "generate",
			loading : "<div id=\"loading\" class=\"loading\"></div>",
			validator : {
				'brandcode' : {
					desc : '所属主机厂'
				},
				'dealername' : {
					desc : '经销商名称'
				},
                'dealerid' :{
                    desc : '经销商id'
                },
                'appaccount' : {
                    desc : '账号',
                    reg : /^[A-Za-z0-9]+$/
                },
                'apppwd' : {
                    desc : '密码'
                },
				'custname' : {
					desc : '姓名'
				},
				'jobdesc' : {
					desc : '职位名称'
				},
				'linktel' : {
					desc : '手机号码',
					reg : /^1\d{10}$/
				},
				'email' : {
					desc : '邮箱',
					reg : /^[\w_\-\.]+@([\w_\-]+\.)+[\w_\-]+$/,
					unrequired : true
				}
			}
		},

		init : function(s) {
			s = $.extend({}, WC.account.settings, s);
			WC.account.isbind(function(isbind) {
				var nextStep = s.steps[isbind ? s.last : s.first];
				WC.account.next(nextStep);
			});
		},
		isbind : function(c, s) {
			s = $.extend({}, WC.account.settings, s);
			WC.API.post(s.bindAction, s.session, function(r) {
				try {
					c(JSON.parse(r).data.isbind);
				} catch (e) {
					c(false);
				}
			});
		},
		next : function(step, s) {
 
			s = $.extend({}, WC.account.settings, s);
 
			jQuery("." + s.gen).remove();
 
			var $c = jQuery(s.content).addClass(s.gen);

			jQuery("." + s.pageCls).prepend($c);

			$c.load(step.url, function() {
                    
				WC.account.initform(this, step, s);

				WC.account.loadButtons(this, step.buttons, s);

				WC.account.loadMore(this, s);

				WC.account.goback(s.steps[step.prev], s);
			});
// alert(s.session.brandcode);
            localStorage.setItem("username",s.session.appaccount);//用户名
            localStorage.setItem("pwd",s.session.apppwd);//密码
            localStorage.setItem("custname",s.session.custname);//姓名
            localStorage.setItem("linktel",s.session.linktel);//手机号码
            localStorage.setItem("jobdesc",s.session.jobdesc);//职位
            localStorage.setItem("email",s.session.email);//邮箱
            localStorage.setItem("dealername",s.session.dealername);//经销商名称
            localStorage.setItem("dealerid",s.session.dealerid);//经销商id
            localStorage.setItem("brandcode",s.session.brandcode);// 主机厂编号
            localStorage.setItem("brandname",s.session.brandname);//所属主机厂
            localStorage.setItem("isLogin","0");//设置是否已登入

		},
		goback : function(prev, s) {
			$("." + s.gobackCls).unbind().attr("href", "javascript:void(0)");
			if (prev) {
				$("." + s.gobackCls).click(function() {
					WC.account.next(prev, s);
				});
				$("." + s.gobackCls).find("img").show();
			} else {
				$("." + s.gobackCls).find("img").hide();
			}
		},
		initform : function(c, step, s) {
			jQuery(c).find("input").each(function() {
				this.value = s.session[this.name] || '';
			});
			jQuery(c).find("select").each(function() {
				jQuery(this).val(s.session[this.name] || '');
				jQuery(this).change();
			});
			jQuery(c).find("select").change(function() {
				s.session[this.name] = jQuery(this).val();
			});
			if (step.loader) {
				jQuery.each(step.loader, function(i, e) {
					WC.API.post(e.dataurl, function(resp) {
						try {
							var result = JSON.parse(resp);
							console.log(result);
							if (result.status === 200) {
								jQuery.each(result.data, function(i, b) {
									jQuery('#' + e.id).append(
											jQuery('<option value='
													+ b.brandcode + '>'
													+ b.brandname
													+ '</option>'));
								});
							}
						} catch (e) {

						}
					});
				});
			}
		},
		check : function(data) {
			var res = {
				status : 1
			};
			jQuery.each(WC.account.settings.validator, function(k, v) {
				if (typeof data[k] === 'undefined')
					return true;
                
                if (v.unrequired && data[k] === '')
                    return true;
                        
				if (!v.unrequired && data[k] === '') {
					res.status = 0;
					res.message = v.desc + '为必填项';
					return false;
				}
                        
				if (v.reg && !v.reg.test(data[k])) {
					res.status = 0;
					res.message = v.desc + '格式不正确';
					return false;
				}
			});
			return res;
		},
		loadButtons : function(c, buttons, s, callback) {
			if (!buttons || !buttons.length)
				return;
			var $f = jQuery(s.formline).addClass(s.gen);
			jQuery(c).after($f);
			jQuery.each(buttons, function(i, e) {
				var $b = $(e.innerHtml).html(e.text).appendTo($f);
				$b.click(function() {
					var next = s.steps[e.target];
					if (e.action && next) {
						var result = {}, data = {};
						jQuery.each(e.required, function() {
							s.session[this] = data[this] = jQuery(
									"input[name='" + this + "'],select[name='"
											+ this + "']").val()
									|| s.session[this] || '';
						});
						jQuery.each(data, function(k, v) {
							if (typeof v === 'string')
								data[k] = v.trim();
						});
						result = WC.account.check(data);
						if (result.status !== 1) {
							jQuery(c).find(".error").html(result.message);
							return;
						}
						WC.API.post(e.action, data, function(resp) {
							var result = {
								message : "数据获取失败，请稍候重试！"
							};
							try {
								result = JSON.parse(resp);
								if (result.status === 200) {
									s.session['result'] = result.data;
									WC.account.next(next, s);
									return;
								}
							} catch (e) {
							}
							jQuery(c).find(".error").html(result.message);
						});
					} else if (next) {
						WC.account.next(next, s);
					}
				});
			});
		},

		loadMore : function(p, s, start, end) {
			var arr = s.session.result;
			if (!arr)
				return;
			if (!arr.length) {
				$(p).find("h1").html("没有找到相关公司，请重新输入");
				return;
			}
			start = start || 0;
			end = end || start + 5;
			$(p).find("ul").empty();
			jQuery.each(arr, function(i, e) {

				if (i >= start && i < end) {
					$(p).find("ul").append(
							WC.account.genli(e.dealername, function() {
								jQuery.each(e, function(k, v) {
									s.session[k] = v;
								});
								WC.account.next(s.steps["dealer_sign"], s);
							}));
				}

			});

			if (start > 0) {
				$(p).find("ul").append(WC.account.genli('上一页', function() {
					WC.account.loadMore(p, s, start - 5);
				}, 'paging__ left__'));

			}

			if (end <= arr.length) {
				$(p).find("ul").append(WC.account.genli('下一页', function() {
					WC.account.loadMore(p, s, end);
				}, 'paging__ right__'));
			}

			$('.left__').css('float', 'left').css('text-align', 'left');
			$('.right__').css('float', 'right').css('text-align', 'right');

			$(".paging__").css('width',
					($(".paging__").size() === 2 ? 50 : 100) + '%')

			$(".left__ b").css('background',
					'url(images/arrow-ls.png) no-repeat').css('padding-left',
					'20px');
		},

		genli : function(html, c, cls) {
			var $l = $('<li/>');
			$l.html('<a href=\"javascript:void(0)\" ><b>' + html + '</b></a>');
			$l.find("a").click(c);
			$l.addClass(cls);
			return $l;
		}
	};
	WC.account.init();
})();